/*
 *	D E F . H
 *
 *	purpose:
 *		Global variable definitions for CodEd.
 */

#ifdef	maindef 				/* for MAIN.C */

/* CodEd globals */

short		kbdm[NKBDM]={ 0 };	/* keyboard macro */
char		*execstr = NULLCPTR;/* pointer to string to execute */
char		golabel[NPAT] = "";	/* current line to go to */
int 		execlevel = 0;		/* execution IF level */
			/*
			 * modes: (C)mode (E)xact (V)iew (O)verwrite (M)agic
			 */
char		modecode[]="CEVOM";	/* letters to represent modes */
int 		gmode = MDEXACT;	/* global editor mode */
int 		gfcolor = 15;		/* global foreground color (IWHI) */
int 		gbcolor = 1;		/* global background color (blu) */
boolean		sgarbf = TRUE;		/* TRUE if screen is garbage */
boolean		mpresf = FALSE;		/* TRUE if message in last line */
boolean		clexec = FALSE;		/* command line execution flag */
boolean		mstore = FALSE;		/* storing text to macro flag */
boolean		discmd = TRUE; 		/* display command flag */
boolean		disinp = TRUE; 		/* display input characters */
boolean		hscroll = TRUE;		/* horizontal scrolling flag */
int			hjump = 1;			/* horizontal jump size */
boolean		safesave = FALSE;	/* safe save flag */
BUFFER		*bstore = NULLBPTR;	/* buffer to store macro text to */
int 		vtrow = 0;			/* row location of SW cursor */
int 		vtcol = 0;			/* column location of SW cursor */
int 		ttrow = 999; 		/* row location of HW cursor */
int 		ttcol = 999; 		/* column location of HW cursor */
int 		lbound = 0;			/* leftmost column of current display line*/
int 		metac = CTRL|'[';	/* current meta character */
int 		ctlxc = CTRL|'X';	/* current control X prefix char */
int 		abortc = SPEC|_aA;	/* current abort command char */

int 		quotec = 0x11;		/* quote char during MlReply() */
char		*cname[] =
			{					/* names of colors */
				"BLA","BLU","GRE","CYA","RED","MAG","YEL","WHI",
				"IBLA","IBLU","IGRE","ICYA","IRED","IMAG","IYEL","IWHI"
			};
KILL		*kbufp = NULLKPTR;	/* current kill buffer chunk pointer */
KILL		*kbufh = NULLKPTR;	/* kill buffer header pointer */
int 		kused = KBLOCK; 	/* # of bytes used in kill buffer */
WINDOW		*swindow = NULLWPTR;/* saved window pointer */
short		*kbdptr = NULLSPTR;	/* current position in keyboard buf */
short		*kbdend = &kbdm[0];	/* ptr to end of the keyboard */
int 		kbdmode = STOP; 	/* current keyboard macro mode */
int 		kbdrep = 0; 		/* number of repetitions */
int 		lastkey = 0;		/* last keystoke */
char		errorm[] = "ERROR"; /* error literal */
char		truem[] = "TRUE";	/* true literal */
char		falsem[] = "FALSE"; /* false litereal */
boolean		cmdstatus = TRUE;	/* last command status */
char		lstmsg[NSTRING]="";	/* last MlWrite() message */
char		*lstptr = NULLCPTR;	/* pointer to lstmsg[] */
int			saveflag = 0;		/* flags, saved with the $target var */
int 		rval = 0;			/* return value of a subprocess */
int 		taboff = 0;			/* tab offset for display */
int 		tabsize = 4;		/* current hard tab size */
int 		stabsize = 0;		/* current soft tab size (0 = use hard tabs) */
int			numfuncs = NNAMES;	/* number of user functions */

int 		currow = 0; 		/* cursor row */
int 		curcol = 0; 		/* cursor column */
int 		thisflag = 0;		/* flags, this command */
int 		lastflag = 0;		/* flags, last command */
int 		curgoal = 0;		/* goal for ^P, ^N */
BUFFER		*bheadp = NULLBPTR;	/* head of list of buffers */
BUFFER		*btailp = NULLBPTR;	/* tail of list of buffers */
BUFFER		*curbp = NULLBPTR;	/* current buffer */
BUFFER		*blistp = NULLBPTR;	/* buffer for ^X^B */
WINDOW		*wheadp = NULLWPTR;	/* head of list of windows */
WINDOW		*curwp = NULLWPTR;	/* current window */

char		sres[NBUFN] = "";	/* current screen resolution */
char		pat[NPAT] = "";		/* search pattern */
char		tap[NPAT] = "";		/* reversed pattern array */
char		rpat[NPAT] = "";	/* replacement pattern */

char		*patmatch = NULLCPTR;	/* string that satisfies search command */

/* vars needed for macro debugging output */

boolean		macbug = FALSE; 		/* macro debug flag */
char		outline[NSTRING]="";	/* global string for debug line text */

#if MAGIC
/*
 * The variables magical and rmagical determine if there were actual
 * metacharacters in the search and replace strings - if not, then we don't
 * have to use the slower MAGIC mode search functions.
 */
boolean		magical = FALSE;
boolean		rmagical = FALSE;
MC			mcpat[NPAT] = {{0,(BITMAP)NULLCPTR}};	/* magic pattern */
MC			tapcm[NPAT] = {{0,(BITMAP)NULLCPTR}};	/* reversed magic pattern */
RMC 		rmcpat[NPAT] = {{0,NULLCPTR}};			/* replacement magic array*/

#endif

/* directive name table (this holds the names of all the directives) */

char *dname[] =
{
	"if", "else", "endif", "goto", "return", "endm", "while", "endwhile",
	"break", "force"
};

#else	/* maindef undefined (for all the other .C files) */

/* CodEd globals */

extern short	kbdm[]; 			/* holds kayboard macro data */
extern char		pat[];				/* search pattern */
extern char		rpat[]; 			/* replacement pattern */
extern char		*execstr;			/* pointer to string to execute */
extern char		golabel[];			/* current line to go to */
extern int 		execlevel;			/* execution IF level */
extern char		modecode[]; 		/* letters to represent modes */
extern KEYTAB	keytab[];			/* key bind to functions table */
extern NBIND	names[];			/* name to function table */
extern int 		gmode;				/* global editor mode */
extern int 		gfcolor;			/* global foreground color */
extern int 		gbcolor;			/* global background color */
extern boolean	sgarbf; 			/* state of screen unknown */
extern boolean	mpresf; 			/* stuff in message line */
extern boolean	clexec; 			/* command line execution flag */
extern boolean	mstore; 			/* storing text to macro flag */
extern boolean	discmd; 			/* display command flag */
extern boolean	disinp; 			/* display input characters */
extern boolean	hscroll;			/* horizontal scrolling flag */
extern int		hjump;				/* horizontal jump size */
extern boolean	safesave;			/* safe save flag */
extern BUFFER	*bstore;			/* buffer to store macro text to */
extern int 		vtrow;				/* row location of SW cursor */
extern int 		vtcol;				/* column location of SW cursor */
extern int 		ttrow;				/* row location of HW cursor */
extern int 		ttcol;				/* column location of HW cursor */
extern int 		lbound; 			/* leftmost column of current display line*/
extern int 		metac;				/* current meta character */
extern int 		ctlxc;				/* current ^X prefix char */
extern int 		abortc; 			/* current abort command char */

extern int 		quotec; 			/* quote char during MlReply() */
extern char		*cname[];			/* names of colors */
extern KILL		*kbufp;				/* current kill buffer chunk pointer */
extern KILL		*kbufh;				/* kill buffer header pointer */
extern int 		kused;				/* # of bytes used in KB */
extern WINDOW	*swindow;			/* saved window pointer */
extern short	*kbdptr; 			/* current position in keyboard buf */
extern short	*kbdend; 			/* ptr to end of the keyboard */
extern int 		kbdmode;			/* current keyboard macro mode */
extern int 		kbdrep; 			/* number of repetitions */
extern int 		lastkey;			/* last keystoke */
extern char		errorm[];			/* error literal */
extern char		truem[];			/* true literal */
extern char		falsem[];			/* false literal */
extern boolean	cmdstatus;			/* last command status */
extern char		lstmsg[];			/* last MlWrite() message */
extern char		*lstptr;			/* pointer to lstmsg[] */
extern int 		saveflag;			/* flags, saved with the $target var */
extern int 		rval;				/* return value of a subprocess */
extern int 		taboff; 			/* tab offset for display */
extern int 		tabsize;			/* current hard tab size */
extern int		stabsize;			/* current soft tab size (0=use hard tabs)*/
extern int		numfuncs;			/* number of user functions */

extern int 		currow; 			/* cursor row */
extern int 		curcol; 			/* cursor column */
extern int 		thisflag;			/* flags, this command */
extern int 		lastflag;			/* flags, last command */
extern int 		curgoal;			/* goal for ^P, ^N */
extern BUFFER	*bheadp; 			/* head of list of buffers */
extern BUFFER	*btailp; 			/* tail of list of buffers */
extern BUFFER	*blistp; 			/* buffer for ^X^B */
extern BUFFER	*curbp;				/* current buffer */
extern WINDOW	*wheadp; 			/* head of list of windows */
extern WINDOW	*curwp;				/* current window */

extern char		sres[];				/* current screen resolution */
extern char		pat[];				/* search pattern */
extern char		tap[];				/* reversed pattern array */
extern char		rpat[]; 			/* replacement pattern */

extern char		*patmatch;

extern boolean	macbug; 			/* macro debug flag */
extern char 	outline[];			/* global string to hold debug line text */

#if MAGIC
extern boolean 	magical;
extern boolean	rmagical;
extern MC		mcpat[];			/* the magic pattern */
extern MC		tapcm[];			/* the reversed magic pattern */
extern RMC		rmcpat[];			/* the replacement magic array */
#endif

extern char		*dname[];			/* directive name table */

#endif

#ifndef TERMDEF
extern TERM		term;				/* terminal information */
#endif
