/*
 *	O B I N D . H
 *
 *	purpose:
 *		Initial default key to function bindings for CodEd.
 *
 *	technical notes:
 *		Include AFTER protos.h !!!
 */

#include "kdef.h"			/* extended keycode definitions */

/*
 * Command table.
 * This table is *roughly* in ASCII order, left to right across the
 * characters of the command. This explains the funny location of the
 * control-X commands.
 */
KEYTAB keytab[NBINDS] =
{
	{CTRL|'G',				GotoMark},
	{CTRL|'H',				BackDel},
	{CTRL|'I',				Tab},
	{CTRL|'J',				Indent},
	{CTRL|'K',				KillText},
	{CTRL|'L',				Refresh},
	{CTRL|'M',				NewLine},
	{CTRL|'O',				OpenLine},
	{CTRL|'Q',				Quote},
	{CTRL|'T',				Twiddle},
	{CTRL|'W',				KillRegion},
	{CTRL|'X',				Cex},
	{CTRL|'Y',				Yank},
	{CTLX|CTRL|'B', 		ListBuffers},
	{CTLX|CTRL|'D', 		Detab},
	{CTLX|CTRL|'E', 		Entab},
	{CTLX|CTRL|'F', 		FileFind},
	{CTLX|CTRL|'I', 		InsFile},
	{CTLX|CTRL|'L', 		LowerRegion},
	{CTLX|CTRL|'M', 		DelMode},
	{CTLX|CTRL|'O', 		Deblank},
	{CTLX|CTRL|'R', 		FileRead},
	{CTLX|CTRL|'T', 		Trim},
	{CTLX|CTRL|'U', 		UpperRegion},
	{CTLX|CTRL|'V', 		ViewFile},
	{CTLX|CTRL|'W', 		FileWrite},
	{CTLX|CTRL|'X', 		SwapMark},
	{CTLX|' ',				DelMark},
	{CTLX|'?',				DesKey},
	{CTLX|'!',				Spawn},
	{CTLX|'@',				Pipe},
	{CTLX|'$',				Exec},
	{CTLX|'=',				ShowCPos},
	{CTLX|'(',				BegKbdMac},
	{CTLX|')',				EndKbdMac},
	{CTLX|'<',				Narrow},
	{CTLX|'>',				Widen},
	{CTLX|'0',				DelWind},
	{CTLX|'1',				OnlyWind},
	{CTLX|'2',				SplitWind},
	{CTLX|'A',				SetVar},
	{CTLX|'B',				UseBuffer},
	{CTLX|'C',				DosShell},
	{CTLX|'E',				ExecKbdMac},
	{CTLX|'K',				KillBuffer},
	{CTLX|'M',				AddMode},
	{CTLX|'N',				FileName},
	{CTLX|'W',				Resize},
	{META|CTRL|'E', 		ExecProc},
	{META|CTRL|'F', 		GetFence},
	{META|CTRL|'H',			DelBWord},
	{META|CTRL|'I', 		IndentRegion},
	{META|CTRL|'K', 		UnbindKey},
	{META|CTRL|'L', 		Reposition},
	{META|CTRL|'M', 		DelGMode},
	{META|CTRL|'N', 		NameBuffer},
	{META|CTRL|'R', 		QReplace},
	{META|CTRL|'V', 		NextWindDn},
	{META|CTRL|'Z', 		NextWindUp},
	{META|' ',				SetMark},
	{META|'.',				SetAnchor},
	{META|'~',				UnmarkBuf},
	{META|'C',				CapWord},
	{META|'G',				GotoLine},
	{META|'K',				BindToKey},
	{META|'L',				LowerWord},
	{META|'M',				AddGMode},
	{META|'R',				SReplace},
	{META|'U',				UpperWord},
	{META|'W',				CopyRegion},
	{META|'X',				NamedCmd},
	{META|'Z',				QuickExit},
	{META|SPEC|_sTAB, 		UndentRegion},
	{META|SPEC|_DELETE,		DelFWord},
	{SPEC|_INSERT,			InsSpace},
	{SPEC|_DELETE,			ForwDel},
	{SPEC|_aA,				CmdAbort},
	{SPEC|_aM,				MoveRegion},
	{SPEC|_F1,				ExecMac1},
	{SPEC|_F2,				ExecMac2},
	{SPEC|_F3,				NextWind},
	{SPEC|_F4,				PrevWind},
	{SPEC|_F5,				ForwSearch},
	{SPEC|_F6,				BackSearch},
	{SPEC|_F7,				ForwHunt},
	{SPEC|_F8,				BackHunt},
	{SPEC|_F9,				NextBuffer},
	{SPEC|_F10,				PrevBuffer},
	{SPEC|_sF1,				ExecMac11},
	{SPEC|_sF2,				ExecMac12},
	{SPEC|_sF3,				ExecMac13},
	{SPEC|_sF4,				ExecMac14},
	{SPEC|_sF5,				ExecMac15},
	{SPEC|_sF6,				ExecMac16},
	{SPEC|_sF7,				ExecMac17},
	{SPEC|_sF8,				ExecMac18},
	{SPEC|_sF9,				ExecMac19},
	{SPEC|_sF10,			ExecMac20},
	{SPEC|_cF1,				ExecMac21},
	{SPEC|_cF2,				ExecMac22},
	{SPEC|_cF3,				ExecMac23},
	{SPEC|_cF4,				ExecMac24},
	{SPEC|_cF5,				ExecMac25},
	{SPEC|_cF6,				ExecMac26},
	{SPEC|_cF7,				ExecMac27},
	{SPEC|_cF8,				ExecMac28},
	{SPEC|_cF9,				ExecMac29},
	{SPEC|_cF10,			ExecMac30},
	{SPEC|_aF1,				ExecMac31},
	{SPEC|_aF2,				ExecMac32},
	{SPEC|_aF3,				ExecMac33},
	{SPEC|_aF4,				ExecMac34},
	{SPEC|_aF5,				ExecMac35},
	{SPEC|_aF6,				ExecMac36},
	{SPEC|_aF7,				ExecMac37},
	{SPEC|_aF8,				ExecMac38},
	{SPEC|_aF9,				FileSave},
	{SPEC|_aF10,			Quit},
	{SPEC|_HOME,			GotoBOL},
	{SPEC|_END,				GotoEOL},
	{SPEC|_PGUP,			MoveWindUp},
	{SPEC|_PGDN,			MoveWindDn},
	{SPEC|_LEFT,			BackChar},
	{SPEC|_RIGHT,			ForwChar},
	{SPEC|_UP,				BackLine},
	{SPEC|_DOWN,			ForwLine},
	{SPEC|_cHOME,			GotoBOB},
	{SPEC|_cEND,			GotoEOB},
	{SPEC|_cPGUP,			BackPage},
	{SPEC|_cPGDN,			ForwPage},
	{SPEC|_aS,				BackWord},
	{SPEC|_aD,				ForwWord},
	{SPEC|_aE,				GotoTlow},
	{SPEC|_aX,				GotoBlow},
	{SPEC|_aO,				ShrinkWind},
	{SPEC|_aP,				EnlargeWind},
	{0, 					NULLFPTR}
};
