/*
 *  V G A . C
 *
 *  COPYRIGHT (C) 1990 John W Grothman.  ALL RIGHTS RESERVED.
 *
 *  purpose:
 *		Functions for the VGA.
 *
 *  to do:
 *
 *  technical notes:
 *
 *  modification log:
 *			11/25/90	John W. Grothman
 */

#include <stdio.h>			/* Turbo C++ verison 1.0 */
#include <dos.h>

#include <jwg.h>

union REGS	rg;

uchar		vgaReg[17][3];
uchar		egaReg[17];

uchar		defaultEgaReg[17] =		/* 17th value is the overscan color */
{
	0, 1, 2, 3, 4, 5, 20, 7, 56, 57, 58, 59, 60, 61, 62, 63, 0
};

struct rgbMap
{
	uchar	red;
	uchar	green;
	uchar	blue;
};
typedef struct rgbMap		RGB;

/*		RGB			rgb;		MUST BE DECLARED BY CALLING FUNCTION */

uchar GetEgaReg(regNum)
  uchar		regNum;					/* 0 -> 15 */
{
	rg.h.ah = 0x10;
	rg.h.al = 0x07;
	rg.h.bl = regNum;
	int86(0x10, &rg, &rg);
	return(rg.h.bh);
}

void GetVgaReg(colorReg, rgb)
  uchar		colorReg;				/* 0 -> 64 */
  RGB		*rgb;
{
	rg.h.ah = 0x10;
	rg.h.al = 0x15;
	rg.h.bh = 0x00;
	rg.h.bl = colorReg;
	int86(0x10, &rg, &rg);
	rgb->red = rg.h.dh;
	rgb->green = rg.h.ch;
	rgb->blue = rg.h.cl;
}

void SetEgaReg(colorVal, regNum)
  uchar		colorVal;				/* 0 -> 63 */
  uchar		regNum;					/* 0 -> 15 */
{
	rg.h.ah = 0x10;
	rg.h.al = 0x00;
	rg.h.bl = colorVal;
	rg.h.bh = regNum;
	int86(0x10, &rg, &rg);
}

void SetVgaReg(colorReg, rgb)
  uchar		colorReg;
  RGB		*rgb;
{
	rg.h.ah = 0x10;
	rg.h.al = 0x10;
	rg.h.bh = 0x00;
	rg.h.bl = colorReg;
	rg.h.dh = rgb->red;
	rg.h.ch =- rgb->green;
	rg.h.cl = rgb->blue;
	int86(0x10, &rg, &rg);
}
